#!/usr/bin/php
<?
//CEDA - Version jdd v1.0 Dec 2005<


//**********Debut des variables************
// Le dossier dans lequel on met toutes les photos haute dfinition
$dossier_hi_def="photos_hi_def";
$dossier_photos_hi_def=dir("photos_hi_def");

// caracteristiques de l'image DVD
$l_dvd=720; // longueur

//composantes rvb de la couleur de fond (255,255,255 = blanc)
$r_dvd=255;
$v_dvd=255;
$b_dvd=255;

// image de fond (dvd) (remplace la couleur de fond)
$imagedefonddvd="fond.jpg";
// mettre le nom d'un fichier situ dans la hirarchie de ce script.

// composantes rvb de la couleur du texte (0,0,0 = noir)
$r_texte=0;
$v_texte=0;
$b_texte=0;

$alpha_texte=0;
// niveau de transparence de la couleur du texte. 0 = opaque - 127 = transparent

// format du texte
$nomdelapolicetexte="fonte.ttf";

$nomdelapolicetexte=realpath('.').'/'.$nomdelapolicetexte;

// nom de la police utilise
// Il est ncessaire de copier les fichiers ttf utiliss
// dans le dossier du script
// n'importe quelle police true type (ttf) peut tre utilise

// Les variables qui suivent sont  rgler en fonction de ses gots, de la taille des caractres, etc.

$tailletexte=20;
// taille de la police de texte en pixels. A l'origine 14
$angletexte=0;
// angle du texte en degr. 0 = horizontal
$nbrecaracteresparlignesiimghorizontale=48;
// nbre de caractres par ligne si l'image est horizontale etait 70
$nbrecaracteresparlignesiimgverticale=14;
// idem si l'image est verticale etait 17


// Qualit des images (de 0  100). A 75, gnre des images pour dvd d'une soixantaine de ko.
$qualite_web=75;
$qualite_dvd=75;


//***********Fin des variables***********

//**********debut du programme***********

//tant qu'il y a une photo dans le dossier d'origine

while ($fichier_hi_def=$dossier_photos_hi_def->read()){
     $fichier_dvd="dvd/".$fichier_hi_def;
     if (!file_exists($fichier_dvd)){
//si la photo n'existe pas encore dans dvd, on va la traiter
$photo=$fichier_hi_def;

// on cherche les donnes exif qui nous intressent
  $exif = exif_read_data($dossier_hi_def."/".$photo, 0, true);

 // et qui vont servir aux calculs
  $width_origine_cliche=$exif[EXIF][ExifImageWidth];
  $height_origine_cliche=$exif[EXIF][ExifImageLength];
  $width_computed_cliche=$exif[COMPUTED][Width];
  $height_computed_cliche=$exif[COMPUTED][Height];

//-------------Traitement d'une image
// Cration de l'image DVD

 $img_in=imagecreatefromjpeg($dossier_hi_def."/".$photo);
// On cr une photo  partir du clich dans le dossier 

// image de fond
 $img_out=imagecreatefromjpeg($imagedefonddvd);

 $dimX=imagesx($img_in);
 $dimY=imagesy($img_in);

if ($dimX>$dimY){
 $dimensions_img_X=$l_dvd;
 $dimensions_img_Y=$l_dvd*$dimY/$dimX;
}
else{
 $dimensions_img_Y=$l_dvd;
 $dimensions_img_X=$l_dvd*$dimX/$dimY;
}

 $emplacement_img_X=0;
 $emplacement_img_Y=0;

imagecopyresampled($img_out,$img_in,$emplacement_img_X,$emplacement_img_Y,0,0,$dimensions_img_X,$dimensions_img_Y,imagesx($img_in),imagesy($img_in));

// le texte

 // on cherche les donnes exif qui nous intressent
  $exif = exif_read_data($dossier_hi_def."/".$photo, 0, true);

 // on dispatche les renseignements qui vont tre utiliss
  $date_en_clair=$exif[EXIF][DateTimeOriginal];
  $modele_cliche=$exif[IFD0][Model];
  $exposition_cliche=$exif[EXIF][ExposureTime];
  $ouverture_cliche=$exif[COMPUTED][ApertureFNumber];
  $iso_cliche=$exif[EXIF][ISOSpeedRatings];
  $commentaire=$exif[COMMENT][0];

$texte="\n".$date_en_clair." ".$modele_cliche." ".$exposition_cliche." ".$ouverture_cliche." ".$iso_cliche."\n".$commentaire;

 $arr=ImageTTFBBox(15,0,$nomdelapolicetexte,$texte);
 $arr[2]+=20;
 $arr[3]+=20;


$couleurtexte=imageColorAllocatealpha($img_out,$r_texte,$v_texte,$b_texte,$alpha_texte);

//image horizontale
if ($dimensions_img_X>$dimensions_img_Y){
 $texte = wordwrap($texte, $nbrecaracteresparlignesiimghorizontale, "\n", 1);
 $textey=$dimensions_img_Y+20;
 $textex=20;
 ImageTTFText($img_out,$tailletexte,$angletexte,$textex,$textey,$couleurtexte,$nomdelapolicetexte,$texte);
 }
// image verticale
else{
 $texte = wordwrap($texte, $nbrecaracteresparlignesiimgverticale, "\n", 1);
 $textex=$dimensions_img_X+10;
 $textey=20;
 ImageTTFText($img_out,$tailletexte,$angletexte,$textex,$textey,$couleurtexte,$nomdelapolicetexte,$texte);
}


 $t=imagejpeg($img_out,'dvd/'.$photo,$qualite_dvd);
 imagedestroy($img_out);


echo "*";

 } // if !file_exists dans le dossier dvd
} // while de parcours du dossier hi_def (tout au dbut)
echo "\n";
?>
